=== modified file 'ChangeLog'
--- ChangeLog	2009-09-08 10:52:24 +0000
+++ ChangeLog	2009-09-08 10:54:00 +0000
@@ -3,6 +3,8 @@
 
 ------- 1.0.09 RC3 - Not released yet
 
+RN269: Implemented online backup. A native online backup driver now performs BACKUP and RESTORE DATABASE operations for PBXT. NOTE: This feature is only supported by MySQL 6.0.9 or later.
+
 RN268: Implemented XA support. PBXT now supports all XA related MySQL statements. The variable pbxt_support_xa determines if XA support is enabled. Note: due to MySQL bug #47134, enabling XA support could lead to a crash. 
 
 ------- 1.0.08d RC2 - 2009-09-02

=== modified file 'src/Makefile.am'
--- src/Makefile.am	2009-07-27 22:39:29 +0000
+++ src/Makefile.am	2009-09-08 10:54:00 +0000
@@ -15,7 +15,7 @@
 						sortedlist_xt.h strutil_xt.h \
 						tabcache_xt.h table_xt.h trace_xt.h thread_xt.h \
 						util_xt.h xaction_xt.h xactlog_xt.h lock_xt.h \
-						systab_xt.h ha_xtsys.h discover_xt.h \
+						systab_xt.h ha_xtsys.h discover_xt.h backup_xt.h \
 						pbms.h pbms_enabled.h xt_config.h xt_defs.h xt_errno.h locklist_xt.h
 
 plugin_LTLIBRARIES =	libpbxt.la
@@ -26,7 +26,7 @@
 						memory_xt.cc myxt_xt.cc pthread_xt.cc restart_xt.cc \
 						pbms_enabled.cc sortedlist_xt.cc strutil_xt.cc \
 						tabcache_xt.cc table_xt.cc trace_xt.cc thread_xt.cc \
-						systab_xt.cc ha_xtsys.cc discover_xt.cc \
+						systab_xt.cc ha_xtsys.cc discover_xt.cc backup_xt.cc \
 						util_xt.cc xaction_xt.cc xactlog_xt.cc lock_xt.cc locklist_xt.cc
 
 libpbxt_la_LDFLAGS =	-module

=== modified file 'src/Makefile.in'
--- src/Makefile.in	2009-07-30 15:48:13 +0000
+++ src/Makefile.in	2009-09-08 10:54:00 +0000
@@ -66,9 +66,9 @@
 	libpbxt_a-table_xt.$(OBJEXT) libpbxt_a-trace_xt.$(OBJEXT) \
 	libpbxt_a-thread_xt.$(OBJEXT) libpbxt_a-systab_xt.$(OBJEXT) \
 	libpbxt_a-ha_xtsys.$(OBJEXT) libpbxt_a-discover_xt.$(OBJEXT) \
-	libpbxt_a-util_xt.$(OBJEXT) libpbxt_a-xaction_xt.$(OBJEXT) \
-	libpbxt_a-xactlog_xt.$(OBJEXT) libpbxt_a-lock_xt.$(OBJEXT) \
-	libpbxt_a-locklist_xt.$(OBJEXT)
+	libpbxt_a-backup_xt.$(OBJEXT) libpbxt_a-util_xt.$(OBJEXT) \
+	libpbxt_a-xaction_xt.$(OBJEXT) libpbxt_a-xactlog_xt.$(OBJEXT) \
+	libpbxt_a-lock_xt.$(OBJEXT) libpbxt_a-locklist_xt.$(OBJEXT)
 am_libpbxt_a_OBJECTS = $(am__objects_1)
 libpbxt_a_OBJECTS = $(am_libpbxt_a_OBJECTS)
 libxtutil_a_AR = $(AR) $(ARFLAGS)
@@ -99,9 +99,10 @@
 	libpbxt_la-tabcache_xt.lo libpbxt_la-table_xt.lo \
 	libpbxt_la-trace_xt.lo libpbxt_la-thread_xt.lo \
 	libpbxt_la-systab_xt.lo libpbxt_la-ha_xtsys.lo \
-	libpbxt_la-discover_xt.lo libpbxt_la-util_xt.lo \
-	libpbxt_la-xaction_xt.lo libpbxt_la-xactlog_xt.lo \
-	libpbxt_la-lock_xt.lo libpbxt_la-locklist_xt.lo
+	libpbxt_la-discover_xt.lo libpbxt_la-backup_xt.lo \
+	libpbxt_la-util_xt.lo libpbxt_la-xaction_xt.lo \
+	libpbxt_la-xactlog_xt.lo libpbxt_la-lock_xt.lo \
+	libpbxt_la-locklist_xt.lo
 libpbxt_la_OBJECTS = $(am_libpbxt_la_OBJECTS)
 libpbxt_la_LINK = $(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CXXLD) $(libpbxt_la_CXXFLAGS) \
@@ -248,7 +249,7 @@
 						sortedlist_xt.h strutil_xt.h \
 						tabcache_xt.h table_xt.h trace_xt.h thread_xt.h \
 						util_xt.h xaction_xt.h xactlog_xt.h lock_xt.h \
-						systab_xt.h ha_xtsys.h discover_xt.h \
+						systab_xt.h ha_xtsys.h discover_xt.h backup_xt.h \
 						pbms.h pbms_enabled.h xt_config.h xt_defs.h xt_errno.h locklist_xt.h
 
 plugin_LTLIBRARIES = libpbxt.la
@@ -258,7 +259,7 @@
 						memory_xt.cc myxt_xt.cc pthread_xt.cc restart_xt.cc \
 						pbms_enabled.cc sortedlist_xt.cc strutil_xt.cc \
 						tabcache_xt.cc table_xt.cc trace_xt.cc thread_xt.cc \
-						systab_xt.cc ha_xtsys.cc discover_xt.cc \
+						systab_xt.cc ha_xtsys.cc discover_xt.cc backup_xt.cc \
 						util_xt.cc xaction_xt.cc xactlog_xt.cc lock_xt.cc locklist_xt.cc
 
 libpbxt_la_LDFLAGS = -module
@@ -358,6 +359,7 @@
 distclean-compile:
 	-rm -f *.tab.c
 
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_a-backup_xt.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_a-bsearch_xt.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_a-cache_xt.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_a-ccutils_xt.Po@am__quote@
@@ -389,6 +391,7 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_a-util_xt.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_a-xaction_xt.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_a-xactlog_xt.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_la-backup_xt.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_la-bsearch_xt.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_la-cache_xt.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libpbxt_la-ccutils_xt.Plo@am__quote@
@@ -808,6 +811,20 @@
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_a_CXXFLAGS) $(CXXFLAGS) -c -o libpbxt_a-discover_xt.obj `if test -f 'discover_xt.cc'; then $(CYGPATH_W) 'discover_xt.cc'; else $(CYGPATH_W) '$(srcdir)/discover_xt.cc'; fi`
 
+libpbxt_a-backup_xt.o: backup_xt.cc
+@am__fastdepCXX_TRUE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_a_CXXFLAGS) $(CXXFLAGS) -MT libpbxt_a-backup_xt.o -MD -MP -MF $(DEPDIR)/libpbxt_a-backup_xt.Tpo -c -o libpbxt_a-backup_xt.o `test -f 'backup_xt.cc' || echo '$(srcdir)/'`backup_xt.cc
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libpbxt_a-backup_xt.Tpo $(DEPDIR)/libpbxt_a-backup_xt.Po
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='backup_xt.cc' object='libpbxt_a-backup_xt.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_a_CXXFLAGS) $(CXXFLAGS) -c -o libpbxt_a-backup_xt.o `test -f 'backup_xt.cc' || echo '$(srcdir)/'`backup_xt.cc
+
+libpbxt_a-backup_xt.obj: backup_xt.cc
+@am__fastdepCXX_TRUE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_a_CXXFLAGS) $(CXXFLAGS) -MT libpbxt_a-backup_xt.obj -MD -MP -MF $(DEPDIR)/libpbxt_a-backup_xt.Tpo -c -o libpbxt_a-backup_xt.obj `if test -f 'backup_xt.cc'; then $(CYGPATH_W) 'backup_xt.cc'; else $(CYGPATH_W) '$(srcdir)/backup_xt.cc'; fi`
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libpbxt_a-backup_xt.Tpo $(DEPDIR)/libpbxt_a-backup_xt.Po
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='backup_xt.cc' object='libpbxt_a-backup_xt.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_a_CXXFLAGS) $(CXXFLAGS) -c -o libpbxt_a-backup_xt.obj `if test -f 'backup_xt.cc'; then $(CYGPATH_W) 'backup_xt.cc'; else $(CYGPATH_W) '$(srcdir)/backup_xt.cc'; fi`
+
 libpbxt_a-util_xt.o: util_xt.cc
 @am__fastdepCXX_TRUE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_a_CXXFLAGS) $(CXXFLAGS) -MT libpbxt_a-util_xt.o -MD -MP -MF $(DEPDIR)/libpbxt_a-util_xt.Tpo -c -o libpbxt_a-util_xt.o `test -f 'util_xt.cc' || echo '$(srcdir)/'`util_xt.cc
 @am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libpbxt_a-util_xt.Tpo $(DEPDIR)/libpbxt_a-util_xt.Po
@@ -1088,6 +1105,13 @@
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_la_CXXFLAGS) $(CXXFLAGS) -c -o libpbxt_la-discover_xt.lo `test -f 'discover_xt.cc' || echo '$(srcdir)/'`discover_xt.cc
 
+libpbxt_la-backup_xt.lo: backup_xt.cc
+@am__fastdepCXX_TRUE@	$(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_la_CXXFLAGS) $(CXXFLAGS) -MT libpbxt_la-backup_xt.lo -MD -MP -MF $(DEPDIR)/libpbxt_la-backup_xt.Tpo -c -o libpbxt_la-backup_xt.lo `test -f 'backup_xt.cc' || echo '$(srcdir)/'`backup_xt.cc
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libpbxt_la-backup_xt.Tpo $(DEPDIR)/libpbxt_la-backup_xt.Plo
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='backup_xt.cc' object='libpbxt_la-backup_xt.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_la_CXXFLAGS) $(CXXFLAGS) -c -o libpbxt_la-backup_xt.lo `test -f 'backup_xt.cc' || echo '$(srcdir)/'`backup_xt.cc
+
 libpbxt_la-util_xt.lo: util_xt.cc
 @am__fastdepCXX_TRUE@	$(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libpbxt_la_CXXFLAGS) $(CXXFLAGS) -MT libpbxt_la-util_xt.lo -MD -MP -MF $(DEPDIR)/libpbxt_la-util_xt.Tpo -c -o libpbxt_la-util_xt.lo `test -f 'util_xt.cc' || echo '$(srcdir)/'`util_xt.cc
 @am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libpbxt_la-util_xt.Tpo $(DEPDIR)/libpbxt_la-util_xt.Plo

=== added file 'src/backup_xt.cc'
--- src/backup_xt.cc	1970-01-01 00:00:00 +0000
+++ src/backup_xt.cc	2009-09-08 10:54:00 +0000
@@ -0,0 +1,594 @@
+/* Copyright (c) 2009 PrimeBase Technologies GmbH
+ *
+ * PrimeBase XT
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ *
+ * 2009-09-07	Paul McCullagh
+ *
+ * H&G2JCtL
+ */
+
+#include "xt_config.h"
+
+#if MYSQL_VERSION_ID >= 60009
+
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <time.h>
+#include <ctype.h>
+
+#include "mysql_priv.h"
+#include <backup/api_types.h>
+#include <backup/backup_engine.h>
+#include <backup/backup_aux.h>         // for build_table_list()
+#include <hash.h>
+
+#include "ha_pbxt.h"
+
+#include "backup_xt.h"
+#include "pthread_xt.h"
+#include "filesys_xt.h"
+#include "database_xt.h"
+#include "strutil_xt.h"
+#include "memory_xt.h"
+#include "trace_xt.h"
+#include "myxt_xt.h"
+
+#ifdef OK
+#undef OK
+#endif
+
+#ifdef byte
+#undef byte
+#endif
+
+using backup::byte;
+using backup::result_t;
+using backup::version_t;
+using backup::Table_list;
+using backup::Table_ref;
+using backup::Buffer;
+
+#define XT_TRACE_CALL()				ha_trace_function(__FUNC__, NULL)
+
+#define XT_RESTORE_BATCH_SIZE		10000
+
+#define BUP_STATE_BEFORE_LOCK		0
+#define BUP_STATE_AFTER_LOCK		1
+
+#define BUP_STANDARD_VAR_RECORD		1
+
+/*
+ * -----------------------------------------------------------------------
+ * UTILITIES
+ */
+
+static void ha_trace_function(const char *function, char *table)
+{
+	char		func_buf[50], *ptr;
+	XTThreadPtr	thread = xt_get_self(); 
+	
+	if ((ptr = strchr(function, '('))) {
+		ptr--;
+		while (ptr > function) {
+			if (!(isalnum(*ptr) || *ptr == '_'))
+				break;
+			ptr--;
+		}
+		ptr++;
+		xt_strcpy(50, func_buf, ptr);
+		if ((ptr = strchr(func_buf, '(')))
+			*ptr = 0;
+	}
+	else
+		xt_strcpy(50, func_buf, function);
+	if (table)
+		printf("%s %s (%s)\n", thread ? thread->t_name : "-unknown-", func_buf, table);
+	else
+		printf("%s %s\n", thread ? thread->t_name : "-unknown-", func_buf);
+}
+
+/*
+ * -----------------------------------------------------------------------
+ * BACKUP DRIVER
+ */
+
+class PBXTBackupDriver: public Backup_driver
+{
+	public:
+	PBXTBackupDriver(const Table_list &);
+	virtual ~PBXTBackupDriver();
+
+	virtual size_t		size();
+	virtual size_t		init_size();
+	virtual result_t	begin(const size_t);
+	virtual result_t	end();
+	virtual result_t	get_data(Buffer &);
+	virtual result_t	prelock();
+	virtual result_t	lock();
+	virtual result_t	unlock();
+	virtual result_t	cancel();
+	virtual void		free();
+	void				lock_tables_TL_READ_NO_INSERT();
+
+	private:
+	XTThreadPtr		bd_thread;
+	int				bd_state;
+	u_int			bd_table_no;
+	XTOpenTablePtr	bd_ot;
+	xtWord1			*db_row_buf;
+};
+
+
+PBXTBackupDriver::PBXTBackupDriver(const Table_list &tables):
+Backup_driver(tables),
+bd_state(BUP_STATE_BEFORE_LOCK),
+bd_table_no(0),
+bd_ot(NULL),
+db_row_buf(NULL)
+{
+}
+
+PBXTBackupDriver::~PBXTBackupDriver()
+{
+}
+
+/** Estimates total size of backup. @todo improve it */
+size_t PBXTBackupDriver::size()
+{
+	XT_TRACE_CALL();
+	return UNKNOWN_SIZE;
+}
+
+/** Estimates size of backup before lock. @todo improve it */
+size_t PBXTBackupDriver::init_size()
+{
+	XT_TRACE_CALL();
+	return 0;
+}
+
+result_t PBXTBackupDriver::begin(const size_t)
+{
+	THD				*thd = current_thd;
+	XTExceptionRec	e;
+
+	XT_TRACE_CALL();
+	
+	if (!(bd_thread = xt_ha_set_current_thread(thd, &e))) {
+		xt_log_exception(NULL, &e, XT_LOG_DEFAULT);
+		return backup::ERROR;
+	}
+	
+	return backup::OK;
+}
+
+result_t PBXTBackupDriver::end()
+{
+	XT_TRACE_CALL();
+	if (bd_ot) {
+		xt_tab_seq_exit(bd_ot);
+		xt_db_return_table_to_pool_ns(bd_ot);
+		bd_ot = NULL;
+	}
+	if (bd_thread->st_xact_data) {
+		if (!xt_xn_commit(bd_thread))
+			return backup::ERROR;
+	}
+	return backup::OK;
+}
+
+result_t PBXTBackupDriver::get_data(Buffer &buf)
+{
+	xtBool	eof;
+	size_t	size, tfer;
+	xtWord4	row_len;
+	xtWord1	*buffer;
+
+	XT_TRACE_CALL();
+
+	if (bd_state == BUP_STATE_BEFORE_LOCK) {
+		buf.table_num = 0;
+		buf.size = 0;
+		buf.last = FALSE;
+		return backup::READY;
+	}
+
+	/* Open the backup table: */
+	if (!bd_ot) {
+		XTThreadPtr		self = bd_thread;
+		XTTableHPtr		tab;
+		char			path[PATH_MAX];
+	
+		if (bd_table_no == m_tables.count()) {
+			buf.size = 0;
+			buf.table_num = 0;
+			buf.last = TRUE;
+			return backup::DONE;
+		}
+		
+		m_tables[bd_table_no].internal_name(path, sizeof(path));
+		bd_table_no++;
+		try_(a)	{
+			xt_ha_open_database_of_table(self, (XTPathStrPtr) path);
+			tab = xt_use_table(self, (XTPathStrPtr) path, FALSE, FALSE, NULL);
+			pushr_(xt_heap_release, tab);
+			if (!(bd_ot = xt_db_open_table_using_tab(tab, bd_thread)))
+				xt_throw(self);
+			freer_(); // xt_heap_release(tab)
+
+			/* Prepare the seqential scan: */
+			xt_tab_seq_exit(bd_ot);
+			if (!xt_tab_seq_init(bd_ot))
+				xt_throw(self);
+			
+			if (db_row_buf) {
+				xt_free(self, db_row_buf);
+				db_row_buf = NULL;
+			}
+			db_row_buf = (xtWord1 *) xt_malloc(self, bd_ot->ot_table->tab_dic.dic_mysql_buf_size);
+			bd_ot->ot_cols_req = bd_ot->ot_table->tab_dic.dic_no_of_cols;
+		}
+		catch_(a) {
+			;
+		}
+		cont_(a);
+
+		if (!bd_ot)
+			goto failed;
+	}
+
+	buf.table_num = bd_table_no;
+	size = buf.size;
+	tfer = 0;
+	buffer = (xtWord1 *) buf.data;
+	while (size > 1) {
+		if (!xt_tab_seq_next(bd_ot, db_row_buf, &eof))
+			goto failed;
+		if (eof) {
+			/* We will go the next table, on the next call. */
+			xt_tab_seq_exit(bd_ot);
+			xt_db_return_table_to_pool_ns(bd_ot);
+			bd_ot = NULL;
+			break;
+		}
+		if (!(row_len = myxt_store_row_data(bd_ot, 1, (char *) db_row_buf)))
+			goto failed;
+		if (row_len > size) {
+			/* Does not fit: */
+			if (row_len > buf.size) {
+				xt_register_xterr(XT_REG_CONTEXT, XT_ERR_BUFFER_TOO_SMALL);
+				goto failed;
+			}
+			xt_tab_seq_repeat(bd_ot);
+			break;
+		}
+		*buffer = BUP_STANDARD_VAR_RECORD;	// Record type identifier.
+		memcpy(buffer+1, bd_ot->ot_row_wbuffer+1, row_len-1);
+		buffer += row_len;
+		tfer += row_len;
+		size -= row_len;
+	}
+	
+	buf.size = tfer;
+	/* This indicates wnd of data for a table! */
+    buf.last = eof;
+
+	return backup::OK;
+
+	failed:
+	xt_log_and_clear_exception(bd_thread);
+	return backup::ERROR;
+}
+
+result_t PBXTBackupDriver::prelock()
+{
+	XT_TRACE_CALL();
+	return backup::READY;
+}
+
+result_t PBXTBackupDriver::lock()
+{
+	XT_TRACE_CALL();
+	if (!xt_xn_begin(bd_thread))
+		return backup::ERROR;
+	bd_state = BUP_STATE_AFTER_LOCK;
+	return backup::OK;
+}
+
+result_t PBXTBackupDriver::unlock()
+{
+	XT_TRACE_CALL();
+	return backup::OK;
+}
+
+result_t PBXTBackupDriver::cancel()
+{
+	XT_TRACE_CALL();
+	return backup::OK; // free() will be called and suffice
+}
+
+void PBXTBackupDriver::free()
+{
+	XT_TRACE_CALL();
+	if (bd_ot) {
+		xt_tab_seq_exit(bd_ot);
+		xt_db_return_table_to_pool_ns(bd_ot);
+		bd_ot = NULL;
+	}
+	if (db_row_buf) {
+		xt_free_ns(db_row_buf);
+		db_row_buf = NULL;
+	}
+	if (bd_thread->st_xact_data)
+		xt_xn_rollback(bd_thread);
+	delete this;
+}
+
+void PBXTBackupDriver::lock_tables_TL_READ_NO_INSERT()
+{
+	XT_TRACE_CALL();
+}
+
+/*
+ * -----------------------------------------------------------------------
+ * BACKUP DRIVER
+ */
+
+class PBXTRestoreDriver: public Restore_driver
+{
+	public:
+	PBXTRestoreDriver(const Table_list &tables);
+	virtual ~PBXTRestoreDriver();
+
+	virtual result_t  begin(const size_t);
+	virtual result_t  end();
+	virtual result_t  send_data(Buffer &buf);
+	virtual result_t  cancel();
+	virtual void      free();
+	
+	private:
+	XTThreadPtr		rd_thread;
+	u_int			rd_table_no;
+	XTOpenTablePtr	rd_ot;
+	xtWord1			*rb_row_buf;
+	u_int			rb_col_cnt;
+	u_int			rb_insert_count;
+};
+
+PBXTRestoreDriver::PBXTRestoreDriver(const Table_list &tables):
+Restore_driver(tables),
+rd_thread(NULL),
+rd_table_no(0),
+rd_ot(NULL),
+rb_row_buf(NULL)
+{
+}
+
+PBXTRestoreDriver::~PBXTRestoreDriver()
+{
+}
+
+result_t PBXTRestoreDriver::begin(const size_t)
+{
+	THD				*thd = current_thd;
+	XTExceptionRec	e;
+	
+	XT_TRACE_CALL();
+	
+	if (!(rd_thread = xt_ha_set_current_thread(thd, &e))) {
+		xt_log_exception(NULL, &e, XT_LOG_DEFAULT);
+		return backup::ERROR;
+	}
+	
+	return backup::OK;
+}
+
+result_t PBXTRestoreDriver::end()
+{
+	XT_TRACE_CALL();
+	if (rd_ot) {
+		xt_db_return_table_to_pool_ns(rd_ot);
+		rd_ot = NULL;
+	}
+	if (rb_row_buf) {
+		xt_free_ns(rb_row_buf);
+		rb_row_buf = NULL;
+	}
+	if (rd_thread->st_xact_data) {
+		if (!xt_xn_commit(rd_thread))
+			return backup::ERROR;
+	}
+	return backup::OK;
+}
+
+
+result_t PBXTRestoreDriver::send_data(Buffer &buf)
+{
+	size_t	size;
+	xtWord1	*buffer;
+	xtWord4	row_len;
+
+	XT_TRACE_CALL();
+
+	if (buf.table_num != rd_table_no) {
+		XTThreadPtr		self = rd_thread;
+		XTTableHPtr		tab;
+		char			path[PATH_MAX];
+		
+		if (rd_ot) {
+			xt_db_return_table_to_pool_ns(rd_ot);
+			rd_ot = NULL;
+		}
+
+		if (rd_thread->st_xact_data) {
+			if (!xt_xn_commit(rd_thread))
+				goto failed;
+		}
+		if (!xt_xn_begin(rd_thread))
+			goto failed;
+		rb_insert_count = 0;
+		
+		rd_table_no = buf.table_num;
+		m_tables[rd_table_no-1].internal_name(path, sizeof(path));
+		try_(a)	{
+			xt_ha_open_database_of_table(self, (XTPathStrPtr) path);
+			tab = xt_use_table(self, (XTPathStrPtr) path, FALSE, FALSE, NULL);
+			pushr_(xt_heap_release, tab);
+			if (!(rd_ot = xt_db_open_table_using_tab(tab, rd_thread)))
+				xt_throw(self);
+			freer_(); // xt_heap_release(tab)
+
+			if (rb_row_buf) {
+				xt_free(self, rb_row_buf);
+				rb_row_buf = NULL;
+			}
+			rb_row_buf = (xtWord1 *) xt_malloc(self, rd_ot->ot_table->tab_dic.dic_mysql_buf_size);
+			rb_col_cnt = rd_ot->ot_table->tab_dic.dic_no_of_cols;
+		}
+		catch_(a) {
+			;
+		}
+		cont_(a);
+		
+		if (!rd_ot)
+			goto failed;
+	}
+
+	buffer = (xtWord1 *) buf.data;
+	size = buf.size;
+
+	while (size > 0) {
+		if (*buffer != BUP_STANDARD_VAR_RECORD) {
+			xt_register_xterr(XT_REG_CONTEXT, XT_ERR_BAD_BACKUP_FORMAT);
+			goto failed;
+		}
+
+		if (!(row_len = myxt_load_row_data(rd_ot, buffer+1, rb_row_buf, rb_col_cnt)))
+			goto failed;
+
+		if (!xt_tab_new_record(rd_ot, rb_row_buf))
+			goto failed;
+
+		buffer += row_len+1;
+		size -= row_len+1;
+
+		rb_insert_count++;
+		if (rb_insert_count == XT_RESTORE_BATCH_SIZE) {
+			if (!xt_xn_commit(rd_thread))
+				goto failed;
+			if (!xt_xn_begin(rd_thread))
+				goto failed;
+			rb_insert_count = 0;
+		}
+	}
+
+	return backup::OK;
+	
+	failed:
+	xt_log_and_clear_exception(rd_thread);
+	return backup::ERROR;
+}
+
+
+result_t PBXTRestoreDriver::cancel()
+{
+	XT_TRACE_CALL();
+	/* Nothing to do in cancel(); free() will suffice */
+	return backup::OK;
+}
+
+void PBXTRestoreDriver::free()
+{
+	XT_TRACE_CALL();
+	if (rd_ot) {
+		xt_db_return_table_to_pool_ns(rd_ot);
+		rd_ot = NULL;
+	}
+	if (rb_row_buf) {
+		xt_free_ns(rb_row_buf);
+		rb_row_buf = NULL;
+	}
+	if (rd_thread->st_xact_data)
+		xt_xn_rollback(rd_thread);
+	delete this;
+}
+
+/*
+ * -----------------------------------------------------------------------
+ * BACKUP ENGINE FACTORY
+ */
+
+#define PBXT_BACKUP_VERSION 1
+
+
+class PBXTBackupEngine: public Backup_engine
+{
+	public:
+	PBXTBackupEngine() { };
+
+	virtual version_t version() const {
+		return PBXT_BACKUP_VERSION;
+	};
+
+	virtual result_t get_backup(const uint32, const Table_list &, Backup_driver* &);
+
+	virtual result_t get_restore(const version_t, const uint32, const Table_list &,Restore_driver* &);
+
+	virtual void free()
+	{
+		delete this;
+	}
+};
+
+result_t PBXTBackupEngine::get_backup(const u_int count, const Table_list &tables, Backup_driver* &drv)
+{
+	PBXTBackupDriver *ptr = new PBXTBackupDriver(tables);
+
+	if (!ptr)
+		return backup::ERROR;
+	drv = ptr;
+	return backup::OK;
+}
+
+result_t PBXTBackupEngine::get_restore(const version_t ver, const uint32,
+                             const Table_list &tables, Restore_driver* &drv)
+{
+	if (ver > PBXT_BACKUP_VERSION)
+	{
+		return backup::ERROR;    
+	}
+	
+	PBXTRestoreDriver *ptr = new PBXTRestoreDriver(tables);
+
+	if (!ptr)
+		return backup::ERROR;
+	drv = (Restore_driver *) ptr;
+	return backup::OK;
+}
+
+
+Backup_result_t pbxt_backup_engine(handlerton *self, Backup_engine* &be)
+{
+	be = new PBXTBackupEngine();
+	
+	if (!be)
+		return backup::ERROR;
+	
+	return backup::OK;
+}
+
+#endif

=== added file 'src/backup_xt.h'
--- src/backup_xt.h	1970-01-01 00:00:00 +0000
+++ src/backup_xt.h	2009-09-08 10:54:00 +0000
@@ -0,0 +1,34 @@
+/* Copyright (c) 2009 PrimeBase Technologies GmbH
+ *
+ * PrimeBase XT
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ *
+ * 2009-09-07	Paul McCullagh
+ *
+ * H&G2JCtL
+ */
+
+#ifndef __backup_xt_h__
+#define __backup_xt_h__
+
+#include "xt_defs.h"
+
+#if MYSQL_VERSION_ID >= 60009 && !defined(DRIZZLED)
+
+Backup_result_t pbxt_backup_engine(handlerton *self, Backup_engine* &be);
+
+#endif
+#endif

=== modified file 'src/myxt_xt.cc'
--- src/myxt_xt.cc	2009-09-03 06:16:11 +0000
+++ src/myxt_xt.cc	2009-09-08 10:54:00 +0000
@@ -1486,7 +1486,7 @@
 	return row_size;
 }
 
-static xtWord4 mx_store_row(XTOpenTablePtr ot, xtWord4 row_size, char *rec_buff)
+xtPublic xtWord4 myxt_store_row_data(XTOpenTablePtr ot, xtWord4 row_size, char *rec_buff)
 {
 	TABLE	*table = ot->ot_table->tab_dic.dic_my_table;
 	char	*sdata;
@@ -1614,8 +1614,9 @@
 }
 
 /* Unload from PBXT variable length format to the MySQL row format. */
-xtPublic xtBool myxt_load_row(XTOpenTablePtr ot, xtWord1 *source_buf, xtWord1 *dest_buff, u_int col_cnt)
+xtPublic xtWord4 myxt_load_row_data(XTOpenTablePtr ot, xtWord1 *source_buf, xtWord1 *dest_buff, u_int col_cnt)
 {
+	xtWord1 *input_buf = source_buf;
 	TABLE	*table;
 	xtWord4	len;
 	Field	*curr_field;
@@ -1624,7 +1625,7 @@
 
 	if (!(table = ot->ot_table->tab_dic.dic_my_table)) {
 		xt_register_taberr(XT_REG_CONTEXT, XT_ERR_NO_DICTIONARY, ot->ot_table->tab_name);
-		return FAILED;
+		return 0;
 	}
 
 	/* According to the InnoDB implementation:
@@ -1657,7 +1658,7 @@
 			default: // Length byte
 				if (*source_buf > 240) {
 					xt_register_xterr(XT_REG_CONTEXT, XT_ERR_BAD_RECORD_FORMAT);
-					return FAILED;
+					return 0;
 				}
 				len = *source_buf;
 				source_buf++;
@@ -1671,7 +1672,12 @@
 
 		source_buf += len;
  	}
-	return OK;
+	return (xtWord4) (source_buf - input_buf);
+}
+
+xtPublic xtBool myxt_load_row(XTOpenTablePtr ot, xtWord1 *source_buf, xtWord1 *dest_buff, u_int col_cnt)
+{
+	return myxt_load_row_data(ot, source_buf, dest_buff, col_cnt) != 0;
 }
 
 xtPublic xtBool myxt_find_column(XTOpenTablePtr ot, u_int *col_idx, const char *col_name)
@@ -1784,7 +1790,7 @@
 	else {
 		xtWord4 row_size;
 
-		if (!(row_size = mx_store_row(ot, XT_REC_EXT_HEADER_SIZE, rec_buff)))
+		if (!(row_size = myxt_store_row_data(ot, XT_REC_EXT_HEADER_SIZE, rec_buff)))
 			return FAILED;
 		if (row_size - XT_REC_FIX_EXT_HEADER_DIFF <= ot->ot_rec_size) {	
 			rec_info->ri_fix_rec_buf = (XTTabRecFixDPtr) &ot->ot_row_wbuffer[XT_REC_FIX_EXT_HEADER_DIFF];

=== modified file 'src/myxt_xt.h'
--- src/myxt_xt.h	2009-09-03 06:16:11 +0000
+++ src/myxt_xt.h	2009-09-08 10:54:00 +0000
@@ -52,8 +52,10 @@
 void		myxt_print_key(XTIndexPtr ind, xtWord1 *key_value);
 
 xtWord4		myxt_store_row_length(XTOpenTablePtr ot, char *rec_buff);
+xtWord4		myxt_store_row_data(XTOpenTablePtr ot, xtWord4 row_size, char *rec_buff);
 xtBool		myxt_store_row(XTOpenTablePtr ot, XTTabRecInfoPtr rec_info, char *rec_buff);
 size_t		myxt_load_row_length(XTOpenTablePtr ot, size_t buffer_size, xtWord1 *source_buf, u_int *ret_col_cnt);
+xtWord4		myxt_load_row_data(XTOpenTablePtr ot, xtWord1 *source_buf, xtWord1 *dest_buff, u_int col_cnt);
 xtBool		myxt_load_row(XTOpenTablePtr ot, xtWord1 *source_buf, xtWord1 *dest_buff, u_int col_cnt);
 xtBool		myxt_find_column(XTOpenTablePtr ot, u_int *col_idx, const char *col_name);
 void		myxt_get_column_name(XTOpenTablePtr ot, u_int col_idx, u_int len, char *col_name);

=== modified file 'src/table_xt.h'
--- src/table_xt.h	2009-07-07 15:08:14 +0000
+++ src/table_xt.h	2009-09-08 10:54:00 +0000
@@ -535,6 +535,7 @@
 void				xt_tab_seq_reset(XTOpenTablePtr ot);
 void				xt_tab_seq_exit(XTOpenTablePtr ot);
 xtBool				xt_tab_seq_next(XTOpenTablePtr ot, xtWord1 *buffer, xtBool *eof);
+xtBool				xt_tab_seq_repeat(XTOpenTablePtr ot);
 
 xtBool				xt_tab_new_record(XTOpenTablePtr ot, xtWord1 *buffer);
 xtBool				xt_tab_delete_record(XTOpenTablePtr ot, xtWord1 *buffer);

=== modified file 'src/thread_xt.cc'
--- src/thread_xt.cc	2009-09-03 06:16:11 +0000
+++ src/thread_xt.cc	2009-09-08 10:54:00 +0000
@@ -75,6 +75,13 @@
 /* Global accumulated statistics: */
 static XTStatisticsRec	thr_statistics;
 
+#ifdef DEBUG
+static void break_in_assertion(c_char *expr, c_char *func, c_char *file, u_int line)
+{
+	printf("%s(%s:%d) %s\n", func, file, (int) line, expr);
+}
+#endif
+
 /*
  * -----------------------------------------------------------------------
  * Error logging
@@ -658,6 +665,8 @@
 		case XT_ERR_FK_REF_TEMP_TABLE:		str = "Foreign key may not reference temporary table"; break;
 		case XT_ERR_MYSQL_SHUTDOWN:			str = "Cannot open table, MySQL has shutdown"; break;
 		case XT_ERR_MYSQL_NO_THREAD:		str = "Cannot create thread, MySQL has shutdown"; break;
+		case XT_ERR_BUFFER_TOO_SMALL:		str = "System backup buffer too small"; break;
+		case XT_ERR_BAD_BACKUP_FORMAT:		str = "Unknown or corrupt backup format, restore aborted"; break;
 		default:							str = "Unknown XT error"; break;
 	}
 	return str;
@@ -887,7 +896,7 @@
 #ifdef DEBUG
 	//xt_set_fflush(TRUE);
 	//xt_dump_trace();
-	printf("%s(%s:%d) %s\n", func, file, (int) line, expr);
+	break_in_assertion(expr, func, file, line);
 #ifdef CRASH_ON_ASSERT
 	abort();
 #endif

=== modified file 'src/util_xt.cc'
--- src/util_xt.cc	2009-05-19 14:13:25 +0000
+++ src/util_xt.cc	2009-09-08 10:54:00 +0000
@@ -150,6 +150,23 @@
 	return (xtWord1) (sum ^ (sum >> 24) ^ (sum >> 16) ^ (sum >> 8));
 }
 
+xtPublic xtWord4 xt_get_checksum4(xtWord1 *data, size_t len)
+{
+	register xtWord4	sum = 0, g;
+	xtWord1				*chk;
+
+	chk = data + len - 1;
+	while (chk > data) {
+		sum = (sum << 4) + *chk;
+		if ((g = sum & 0xF0000000)) {
+			sum = sum ^ (g >> 24);
+			sum = sum ^ g;
+		}
+		chk--;
+	}
+	return sum;
+}
+
 /*
  * --------------- Data Buffer ------------------
  */

=== modified file 'src/util_xt.h'
--- src/util_xt.h	2008-06-04 10:48:47 +0000
+++ src/util_xt.h	2009-09-08 10:54:00 +0000
@@ -39,6 +39,7 @@
 xtBool	xt_time_difference(register xtWord4 now, register xtWord4 then);
 xtWord2	xt_get_checksum(xtWord1 *data, size_t len, u_int interval);
 xtWord1 xt_get_checksum1(xtWord1 *data, size_t len);
+xtWord4 xt_get_checksum4(xtWord1 *data, size_t len);
 
 typedef struct XTDataBuffer {
 	size_t			db_size;

=== modified file 'src/xt_defs.h'
--- src/xt_defs.h	2009-05-27 13:17:52 +0000
+++ src/xt_defs.h	2009-09-08 10:54:00 +0000
@@ -379,6 +379,12 @@
  */
 //#define XT_IMPLEMENT_NO_ACTION
 
+/* Define this value if online-backup should be supported.
+ * Note that, online backup is currently only supported
+ * by MySQL 6.0.9 or later
+ */
+#define XT_ENABLE_ONLINE_BACKUP
+
 /* ----------------------------------------------------------------------
  * GLOBAL CONSTANTS
  */
@@ -406,6 +412,8 @@
 
 #define XT_ADD_PTR(p, l)				((void *) ((char *) (p) + (l)))
 
+#define XT_MAX_XA_DATA_SIZE				(3*4 + 128)			/* Corresponds to the maximum size of struct xid_t in handler.h. */
+
 /* ----------------------------------------------------------------------
  * DEFINES DEPENDENT ON  CONSTANTS
  */

=== modified file 'src/xt_errno.h'
--- src/xt_errno.h	2009-09-03 06:16:11 +0000
+++ src/xt_errno.h	2009-09-08 10:54:00 +0000
@@ -119,6 +119,8 @@
 #define XT_ERR_FK_REF_TEMP_TABLE	-95
 #define XT_ERR_MYSQL_SHUTDOWN		-98
 #define XT_ERR_MYSQL_NO_THREAD		-99
+#define XT_ERR_BUFFER_TOO_SMALL		-100
+#define XT_ERR_BAD_BACKUP_FORMAT	-101
 
 #ifdef XT_WIN
 #define XT_ENOMEM					ERROR_NOT_ENOUGH_MEMORY

